<?php

/*
 * $Id: payson.php, v. 0.1.0 2008/02/27 13:27:10 rob Exp $
 *
 * @package Payson gateway for MightyExtensions Bill 
 * @email rob@osdcs.com
 *
 * @copyright
 * ====================================================================
 * Copyright (C) 2008 osdcs.com. All rights reserved.
 * osdcs is not a free software. You may make changes but
 * you may not sell it or distribute it
 * License is for ONE domain only.
 * ====================================================================
 * @endcopyright
 *
 * @BeginFunctionList
 * ====================================================================
 *
 * ====================================================================
 * @EndFunctionList
 *
 *
 * @paypayson.php
 * @brief 
 * Performs payment processing.
 *
 * @history
 * ====================================================================
 * File creation date: 27/02/2008 13:27:10
 * Current file version:0.1.0 
 * ====================================================================
 * @endhistory
 */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.menu');
include('payson.files/language.php');

class plgBill_gatewaysPaypayson extends JPlugin 
{
		var $_db = null;
		function plgBill_gatewaysPaypayson(& $subject, $config) 
		{
			$this->_db = JFactory :: getDBO();
			parent :: __construct($subject, $config);
		}
		
function onReceivePayment(&$post)
{
	$database=$this->_db;
	$mosConfig_live_site = JURI::base();

	$processor = $post['processor'];
	
	if( $processor != 'paypayson' ) 
		return false;
	
	

	if($post['params']){
		$params = new JParameter($post['params']);
	} else {
		$params = $this->params;
	}
		
//Denis, these two attributes not beign set is causig this problem.					
//	$order['user_id']=$post['user_id']; 
//	$order['price']=$post['amount']; 

	$order['price']   = $post['price'];
	$order['user_id'] = $post['uid'];
	$order['sid']     = $post['RefNr'];
	$order['gateway'] = $processor;
	$order['gateway_id'] = date('d-m-y H:i:s').$post['RefNr'];
	
	if (class_exists('Bill')) 
		$order['key']  = strtoupper(md5(Bill::getSecretWord().$order['user_id'].$order['gateway_id'].$order['price'].$order['sid']));
		//die($params->get($post['processor']."_secret"));
		
		//die(print_r( $post , 1 ));
		
		$newHash = md5($post['OkURL'].$post['Paysonref'].$params->get($post['processor']."_secret"));

	$pay=$post['pay'];
	$hash = $post['hash'];
	$status=$post['status'];

	if ($newHash==$_REQUEST['MD5'])
	{
		
		$order['pay'] = "success";
		
	} else {
		
		$order['pay'] = "fail";
		$order['msg'] = OSDCS_PAYSON_FAIL;
		
	}
// }
//print_r($order);die();

return $order;
}
		
		function onSendPayment(&$post) 
		{
	    	$user = JFactory::getUser();
	    	global $Itemid;
		    if($post['processor'] != 'paypayson') return false;
		    
		$invoice = JTable::getInstance( 'invoice', 'Table' );
    $invoice->load( $post['order_id'] );

    $post['params'] = $invoice->params;
//die(print_r($post,1));
		    if($post['params']){
		       	$settings = new JParameter($post['params']);
		    }else{
		       	$settings = $this->params;
		    }
		    
		    $amount    = $post['order_amount'];
			
			$mosConfig_live_site = JURI::base();
			$price=str_replace('.',',',$amount);
			
		    $param2['email']     = $post['email'];
			$param2['option']    = JRequest::getCmd('option');
			$param2['task']      = @$post['task'];
			$param2['view']      = @$post['view'];
			$param2['layout']    = @$post['layout'];
			$param2['processor'] = @$post['processor'];
			$param2['order_id']  = @$post['order_id'];
			$param2['price']     = $price;
			$param2['Itemid']    = $Itemid;
			$param2['uid']       = $user->id;
			$param2['hash']      = md5($price.$settings->get($post['processor']."_secret"));
			
			$params['OkUrl']     = JURI::base().'index.php?'.PPArray2UrlPaySon($param2).'&pay=success';
			$params['CancelUrl']   = $mosConfig_live_site."index.php?option=".$param2['option']."&task=create&view=".$param2['view']."&layout=".$param2['layout']."&processor=".$settings->get($post['processor'])."&pay=error&uid={$user->id}&price=$price&Itemid=$Itemid";			
//			$params['CancelUrl']   = $mosConfig_live_site."index.php?option=com_jcs&task=create&view=jcs&layout=history&processor=paypayson&pay=error&uid={$user->id}&price=$price&Itemid=$Itemid";
		  	$params['AgentId']     = $settings->get($post['processor']."_agentid");
			$params['Cost']		   = str_replace('.',',',$amount);
			$params['Description'] = 'Member';
			$params['ExtraCost']   = 0;			
			$params['SellerEmail'] = $settings->get($post['processor']."_email");
			$params['BuyerEmail']  = $post['email'];
			$params['GuaranteeOffered']	  = $settings->get($post['processor']."_guaranteeoffered");
			$params['MD5']		   = md5($settings->get($post['processor']."_email").":".$params['Cost'].":"."0".":".$params['OkUrl'].":".$params['GuaranteeOffered'].$settings->get($post['processor']."_secret"));
			$params['txntype'] 	   = "sale";
    		$params['uid']         = $post['user_id'];
			$params['RefNr']       = $post['order_id'];
			
			if ($settings->get($post['processor']."_test")==0)
		        {
					$url="https://www.payson.se/merchant/default.aspx";
			} else {
					$url="https://www.payson.se/testagent/default.aspx";
			}

			//$url="https://www.payson.se/merchant/default.aspx";
			?>
			<form action="<?php echo $url?>" method="POST" name="payone_form" id="payson_form">
			<?php echo OSDCS_PAYSON_BYEREMAIL; ?> 
			<?php
			foreach ($params as $key=>$value)
			{
			  	echo "<input type=\"hidden\" name=\"$key\" value=\"$value\" />\r\n";
			}
			
			
			?>
			<!--<input type='submit' value="<?php echo OSDCS_PAYSON_PAY;?>">-->
			</form>
						
			
			<?php
//die();
			if ($settings->get($post['processor']."_usedebug")!=1){
			?>
				<script>
					document.getElementById('payson_form').submit();
				</script>
			<?php
			} 
			else { 
			echo "vies source to see the form";
			}		
			?>
			
			
			<?php
		}
}

function PPArray2UrlPaySon($param)
{
	foreach($param AS $k => $v)
	{
		$out[] = "$k=$v";
	}
	return implode('&', $out );
}
?>
